#define CLK 4                                               // Encoder CLOCK pin to 4 pin of Arduino
#define DT 3                                                // Encoder DATA pin to 3 pin of Arduino
#define SW 2                                                // Encoder SWITCH pin to 2 pin of Arduino

#include <GyverEncoder.h>                                   // include Encoder library
#include <AccelStepper.h>                                   // include Stepper library

Encoder enc(CLK, DT, SW);                                   // 

AccelStepper stepper(1,11,12);                              // 1 - external driver; 11 - STEP pin; 12 - DIR pin
 
int spd = 11;                                               // motor speed in steps/second (11) -> Correction - 7 steps/second
int p = 7;                                                  // beeper pin

void setup()                                                //
{  
  pinMode(8, INPUT_PULLUP);                                 // N/S direction switch
  pinMode(9, INPUT_PULLUP);                                 // start/stop motor switch
  pinMode(6, OUTPUT);                                       //

  pinMode(p, OUTPUT);                                       // buzzer
  
  digitalWrite(6, LOW);                                     //
  
  enc.setType(TYPE2);                                       //
  
  stepper.setMaxSpeed(500);                                 //
  stepper.setSpeed(spd);                                    //
  stepper.setAcceleration(100);                             //

  tone(p,1800,40);                                          // Turn on signal
  delay(80);                                                //
  tone(p,1800,40);                                          //
}

void loop()
{
  if (digitalRead(9) == HIGH) {digitalWrite(6, HIGH);}      // 'start/stop motor' switch position check
  else {digitalWrite(6, LOW);}                              //
    
  enc.tick();                                               // encoder
  if (enc.isTurn()) {                                       // if turned...
    if (enc.isRight()) {spd ++; tone(p,1800,20);}           // ...right, then speed increase by 1
    if (enc.isLeft()) {spd --; tone(p,1200,20);}            // ...left, then speed decrease by 1
    if (enc.isRightH()) {spd += 10; tone(p,1800,60);}       // ...right while pressed, then speed increase by 10
    if (enc.isLeftH()) {spd -= 10; tone(p,1200,60);}        // ...left while pressed, then speed decrease by 10
  }                                                         //
  
  if (enc.isClick()) {                                      // if encoder clicked
    spd = 11;                                               // then set motor speed to default 11 steps/second -> Correction - 7 steps/second
    
    tone(p,1600,40);                                        // Click signal
    delay(80);                                              //
    tone(p,1600,40);                                        //
  }                                                         //

  if (digitalRead(8) == HIGH) {                             // 'N/S direction' switch check
    stepper.setSpeed(spd*(-1));                             //
  }                                                         //
  else {                                                    //
    stepper.setSpeed(spd);                                  //
  }                                                         //
  
  stepper.runSpeed();                                       //
}